; Script generated by the HM NIS Edit Script Wizard.

!ifndef PRODUCT_NAME
	!define PRODUCT_NAME "DeskAlerts"
!endif
!define PRODUCT_PUBLISHER "Softomate, LLC."
!define PRODUCT_COMPANY "Softomate"
!define PRODUCT_WEB_SITE "http://www.softomate.com"
!define PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\DeskAlerts.exe"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"
!define PRODUCT_STARTMENU_REGVAL "NSIS:StartMenuDir"

!ifdef NOSERVER
	!define TRIAL
!endif

!include "WinMessages.nsh"
!include "FileFunc.nsh"
!insertmacro un.GetParameters
!insertmacro un.GetOptions

; MUI 1.67 compatible ------
!include "MUI.nsh"

; MUI Settings
!define MUI_HEADERIMAGE
!define MUI_HEADERIMAGE_BITMAP "deskalerts.bmp" ; optional
;!define MUI_HEADERIMAGE_RIGHT
!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall.ico"

; Language Selection Dialog Settings
;!ifndef NOARP
  !define MUI_LANGDLL_REGISTRY_ROOT "${PRODUCT_UNINST_ROOT_KEY}"
  !define MUI_LANGDLL_REGISTRY_KEY "${PRODUCT_UNINST_KEY}"
  !define MUI_LANGDLL_REGISTRY_VALUENAME "NSIS:Language"
;!endif

; Welcome page
!insertmacro MUI_PAGE_WELCOME

; License page
LicenseLangString license ${LANG_ENGLISH} "License.rtf"
!insertmacro MUI_PAGE_LICENSE $(license)

; Directory page
!define MUI_PAGE_CUSTOMFUNCTION_LEAVE "DirectoryLeave"
!insertmacro MUI_PAGE_DIRECTORY

; Start menu page
var ICONS_GROUP
!define MUI_STARTMENUPAGE_NODISABLE
!define MUI_STARTMENUPAGE_DEFAULTFOLDER "${PRODUCT_NAME}"
!define MUI_STARTMENUPAGE_REGISTRY_ROOT "${PRODUCT_UNINST_ROOT_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_KEY "${PRODUCT_UNINST_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_VALUENAME "${PRODUCT_STARTMENU_REGVAL}"

Page custom SetCustom ValidateCustom ": Environment options" ;Custom page. InstallOptions gets called in SetCustom.

!insertmacro MUI_PAGE_STARTMENU Application $ICONS_GROUP

; Instfiles page
!insertmacro MUI_PAGE_INSTFILES

; Finish page
;!define MUI_FINISHPAGE_RUN "$INSTDIR\DeskAlerts.exe"
;!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "English"
;!insertmacro MUI_LANGUAGE "Russian"

; MUI end ------

;--------------------------------
;Add additional information
VIProductVersion "${PRODUCT_VERSION}"
VIAddVersionKey /LANG=${LANG_ENGLISH} "ProductName" "DeskAlerts Client"
VIAddVersionKey /LANG=${LANG_ENGLISH} "CompanyName" "${PRODUCT_PUBLISHER}"
VIAddVersionKey /LANG=${LANG_ENGLISH} "LegalCopyright" "Copyright (c) 2006-2009 Softomate"
VIAddVersionKey /LANG=${LANG_ENGLISH} "FileDescription" "DeskAlerts Client Installer"
VIAddVersionKey /LANG=${LANG_ENGLISH} "FileVersion" "${PRODUCT_VERSION}"
VIAddVersionKey /LANG=${LANG_ENGLISH} "OriginalFilename" "deskalerts_setup.exe"
!ifdef NOSERVER
	VIAddVersionKey /LANG=${LANG_ENGLISH} "Comments" "Trial Version without server"
!else
	!ifdef TRIAL
		VIAddVersionKey /LANG=${LANG_ENGLISH} "Comments" "Trial Version"
	!endif
!endif
;--------------------------------

Name "${PRODUCT_NAME}"
OutFile "deskalerts_setup.exe"
InstallDir "$PROGRAMFILES\${PRODUCT_NAME}"
InstallDirRegKey HKLM "${PRODUCT_DIR_REGKEY}" ""
XPStyle on
RequestExecutionLevel admin
ShowInstDetails show
ShowUnInstDetails show

ReserveFile "test.ini"

Function .onInit
	InitPluginsDir
	File /oname=$PLUGINSDIR\test.ini "test.ini"
	SetShellVarContext All

	;!insertmacro MUI_LANGDLL_DISPLAY
FunctionEnd

Function DirectoryLeave
	IfFileExists "$INSTDIR\Uninstall ${PRODUCT_NAME}.lnk" 0 if_not_exist
		MessageBox MB_ICONINFORMATION|MB_OK "Please uninstall ${PRODUCT_NAME} first."
		Abort
	if_not_exist:
FunctionEnd

Section "MainSection" SEC01

	DeleteRegKey HKEY_CURRENT_USER "Software\ALERTS00001"

	SetOutPath "$INSTDIR"
	SetOverwrite ifnewer

	File /r ".\tmp\*.*"


; Shortcuts

	!insertmacro MUI_STARTMENU_WRITE_BEGIN Application
	CreateDirectory "$SMPROGRAMS\$ICONS_GROUP"
	CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\${PRODUCT_NAME}.lnk" "$INSTDIR\DeskAlerts.exe"
	CreateShortCut "$SMSTARTUP\${PRODUCT_NAME}.lnk" "$INSTDIR\DeskAlerts.exe" "/newid"
!ifndef NODESKICON
	CreateShortCut "$DESKTOP\${PRODUCT_NAME}.lnk" "$INSTDIR\DeskAlerts.exe"
!endif
	!insertmacro MUI_STARTMENU_WRITE_END

	IfSilent +2
		Exec '$OutDir\deskalerts.exe'
SectionEnd

Section -AdditionalIcons
!ifndef NOUM
	!insertmacro MUI_STARTMENU_WRITE_BEGIN Application
	CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Uninstall ${PRODUCT_NAME}.lnk " "$INSTDIR\uninst.exe"
	!insertmacro MUI_STARTMENU_WRITE_END
!endif
SectionEnd

Section -Post
	WriteUninstaller "$INSTDIR\uninst.exe"
	WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR\DeskAlerts.exe"

!ifndef NOARP
	WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
	WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
	WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\DeskAlerts.exe"
	WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
	WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
	WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
!endif
SectionEnd


Function un.onUninstSuccess
	HideWindow
	;MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) was successfuly removed."
FunctionEnd

Function un.onInit
	SetShellVarContext current
!insertmacro MUI_UNGETLANGUAGE
	${un.GetParameters} $R0
	${un.GetOptions} "$R0" "/s" $R1
	IfErrors 0 silent
	${un.GetOptions} "$R0" "-s" $R1
	IfErrors 0 silent
	${un.GetOptions} "$R0" "/silent" $R1
	IfErrors 0 silent
	${un.GetOptions} "$R0" "-silent" $R1
	IfErrors 0 silent
		MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "This will remove the $(^Name) from your computer! Are you sure?" IDYES end
		Abort
	silent:
		SetSilent silent
	end:
FunctionEnd

Function SetCustom
	;Display the InstallOptions dialog
	Push $0
		InstallOptions::dialog "$PLUGINSDIR\test.ini"
		Pop $0
	Pop $0
FunctionEnd

Function ValidateCustom
	ReadINIStr $0 "$PLUGINSDIR\test.ini" "Field 2" "State"
	StrCmp $0 1 done
		SetShellVarContext Current
	done:
FunctionEnd


Section Uninstall
	Sleep 3000

	;"#32770 (Dialog)"
	;FindWindow $0 "DeskAlertsDialog"
	;SendMessage $0 ${WM_CLOSE} 0 0

	loop:
		FindWindow $0 "#32770 (Dialog)" "DeskAlertsDialog"
		IntCmp $0 0 done
		IsWindow $0 0 done
		System::Call 'user32::PostMessageA(i,i,i,i) i($0,${WM_CLOSE},0,0)'
		Sleep 100
		Goto loop
	done:

	loop2:
		FindWindow $0 "#32770" "DeskAlertsDialog"
		IntCmp $0 0 done2
		IsWindow $0 0 done2
		System::Call 'user32::PostMessageA(i,i,i,i) i($0,${WM_CLOSE},0,0)'
		Sleep 100
		Goto loop2
	done2:

	ProcKiller::closeProgram "" "DeskAlerts.exe"


	!insertmacro MUI_STARTMENU_GETFOLDER "Application" $ICONS_GROUP

	;Exec '"regsvr32.exe" /s /u "$INSTDIR\deskalerts.dll"'

	Sleep 100

	SetShellVarContext current
	Delete "$SMPROGRAMS\$ICONS_GROUP\Uninstall ${PRODUCT_NAME}.lnk "
	Delete "$DESKTOP\${PRODUCT_NAME}.lnk"
	Delete "$SMSTARTUP\${PRODUCT_NAME}.lnk"
	Delete "$SMPROGRAMS\$ICONS_GROUP\${PRODUCT_NAME}.lnk"
	RMDir "$SMPROGRAMS\$ICONS_GROUP"

	SetShellVarContext all
	Delete "$SMPROGRAMS\$ICONS_GROUP\Uninstall ${PRODUCT_NAME}.lnk "
	Delete "$DESKTOP\${PRODUCT_NAME}.lnk"
	Delete "$SMSTARTUP\${PRODUCT_NAME}.lnk"
	Delete "$SMPROGRAMS\$ICONS_GROUP\${PRODUCT_NAME}.lnk"
	RMDir "$SMPROGRAMS\$ICONS_GROUP"



	Delete "$INSTDIR\*.html"
	Delete "$INSTDIR\*.htm"
	Delete "$INSTDIR\*.png"
	Delete "$INSTDIR\*.gif"
	Delete "$INSTDIR\*.bmp"
	Delete "$INSTDIR\*.txt"
	Delete "$INSTDIR\*.wav"
	Delete "$INSTDIR\*.dll"
	Delete "$INSTDIR\*.exe"
	Delete "$INSTDIR\*.xml"
	Delete "$INSTDIR\*.js"
	Delete "$INSTDIR\*.key"
	Delete "$INSTDIR\*.css"
	Delete "$INSTDIR\*.jpg"
	Delete "$INSTDIR\*.jpeg"
	RMDir /r "$INSTDIR\Cache"

	Sleep 1000

	Delete /REBOOTOK "$INSTDIR\unins.exe"


	RMDir /REBOOTOK $INSTDIR
	DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
	DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"
	SetAutoClose false

	DeleteRegKey HKEY_CURRENT_USER "Software\ALERTS00001"

SectionEnd